---
title: FileSystemDirectoryHandle.removeEntry()
slug: Web/API/FileSystemDirectoryHandle/removeEntry
tags:
  - Directory
  - File
  - File System Access API
  - FileSystemDirectoryHandle
  - Method
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>removeEntry()</code></strong> method of the {{domxref("FileSystemDirectoryHandle")}} interface attempts to remove an entry if the directory handle contains a file or directory called the name specified.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">FileSystemDirectoryHandle.removeEntry(name).then...</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>name</em></dt>
 <dd>A {{domxref('USVString')}} representing the {{domxref('FileSystemHandle.name')}} of the entry you wish to remove.</dd>
 <dt><em>options</em> {{optional_inline}}</dt>
 <dd>An optional object containing options, which are as follows:
 <ul>
  <li><code>recursive</code>: A {{jsxref('Boolean')}}. Default <code>false</code>. When set to <code>true</code> entries will be removed recursively.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Promise')}} which resolves with <code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>If the name is not a valid string or contains characters not allowed on the file system</dd>
 <dt><code>NotAllowedError</code></dt>
 <dd>If {{domxref('PermissionStatus')}} is not 'granted'.</dd>
 <dt><code>InvalidModificationError</code></dt>
 <dd>If <code>recursive</code> is set to false and the entry to be removed has children.</dd>
 <dt><code>NotFoundError</code></dt>
 <dd>If an entry name is not found or matched</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example removes an entry within the directory handle.</p>

<pre class="brush: js notranslate">const entryName = 'entryToRemove';

// assuming we have a directory handle: 'currentDirHandle'
currentDirHandle.removeEntry(entryName).then( () =&gt; {
  // code to run if removing was successful
} );</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access API','#api-filesystemdirectoryhandle-removeentry','removeEntry')}}</td>
   <td>{{Spec2('File System Access API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemDirectoryHandle.removeEntry")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
